// 1,2: 3.5, 2
// 3,4: 2.6, 1.5
// Delete and rebuild (Not sure how important this is)
if(isObject(DualRenderScope))
	DualRenderScope.delete();
exec("./DualRenderScope.gui");

$DRScopes_Version = 1;
$DRScopes_DefaultMouseSensitivity 		= $pref::Input::MouseSensitivity;
$Pref::DRScopesMouseSensitivityScale 	= 0.25;

function clientCmdDRScopes_renderDRScope(%fov, %bitmap, %renderW, %renderH)
{	
	// Put us in first person
	if(!$FirstPerson)
		toggleFirstPerson(1);
	
	// Disable F zoom
	if($ZoomOn)
		toggleZoom(0);
		
	// Get and set the optic
	%bitmapPath = "Add-Ons/Client_DualRenderScopes/DR_Optic" @ %bitmap @ ".png";
	ScopeBitmap.setBitmap(%bitmapPath);
	
	// Set magnification
	ScopeRender.forceFOV = %fov;
	
	// Calculate bitmap width based on the resolution height, should always be in 16:9 format
	%bitmapH = getWord(getRes(), 1);
	%bitmapW = (%bitmapH * 16) / 9;
	ScopeBitmap.resize(0, 0, %bitmapW, %bitmapH);
	
	// Set the size of the scope render area, adjusting for resoltuion
	// This is usually done by defaults using values that I've set up per bitmap, but it can be overridden if required
	if(%renderH $= "" || %renderW $= "")
	{
		switch(%bitmap)
		{
			case 0:
				%renderW = 2;
				%renderH = 2.1;
			case 1:
				%renderW = 3.5;
				%renderH = 2;
			case 2:
				%renderW = 3.5;
				%renderH = 2;
			case 3:
				%renderW = 2.6;
				%renderH = 1.5;
			case 4:
				%renderW = 2.6;
				%renderH = 1.5;
			case 5:
				%renderW = 3;
				%renderH = 1.8;
			case 6:
				%renderW = 3;
				%renderH = 2;
			case 7:
				%renderW = 2;
				%renderH = 2;				
			default:
				%renderW = 1;
				%renderH = 1;
		}
	}
	
	%H = mFloatLength(%bitmapH / %renderH, 3);
	%W = mFloatLength(%bitmapW / %renderW, 3);
	ScopeRender.resize(0, 0, %W, %H);
	
	// Center the render area and bitmap
	ScopeRender.setCentered();
	ScopeBitmap.setCentered();
	
	// Add the overlay to the screen and position/resize
	PlayGUI.Add(DualRenderScope);
	DualRenderScope.resize(0, 0, %bitmapW, %bitmapH);
	DualRenderScope.setCentered();
	
	// Bring the centerPrintDLG to the back to that the client can still
	// see centerprints when scoped in.
	PlayGUI.pushToBack(centerPrintDlg);
	
	// Mouse sensitivity, adjusted for FOV
	%fovScale = %fov / 50;
	if(%fovScale > 1)
		%fovScale = 1;
	
	$pref::Input::MouseSensitivity = ($DRScopes_DefaultMouseSensitivity * $Pref::DRScopesMouseSensitivityScale) * %fovScale;
	
	// Scope awareness
	$DualScopeEngaged = true;
	commandToServer('DRScopes_ClientScopedIn');
}
function clientCmdDRScopes_unRenderDRScope()
{
	if(!isObject(DualRenderScope) || !$DualScopeEngaged)
		return;
		
	// Get rid of the render, and return sensitivity to the default value
	PlayGUI.remove(DualRenderScope);
	$pref::Input::MouseSensitivity = $DRScopes_DefaultMouseSensitivity;
	
	// Scope awareness
	$DualScopeEngaged = false;
	commandToServer('DRScopes_ClientScopedOut');
}
function clientCmdDRScopesPing()
{
	// Recieved ping from server, ping back
	echo("Received DRScopes ping from server...");
	commandToServer('DRScopes_PingRespond', $DRScopes_Version);
}

package DualRenderPackage
{
	// Disable first/third person ability while scoped
	function toggleFirstPerson(%val)
	{
		if($DualScopeEngaged && $FirstPerson)
			return;
		
		Parent::toggleFirstPerson(%val);
	}
	
	// Disable zooming in when in DR mode.
	function toggleZoom(%val)
	{
		if(!$DualScopeEngaged || !%val)
		{
			Parent::toggleZoom(%val);
		}
	}
	
	// Unrender scope upon disconnect so it doesn't show up next time a client gets in-game.
	function disconnect(%a)
	{
		clientCmdDRScopes_unRenderDRScope();
		Parent::disconnect(%a);
	}
	
	// Unrender scope when going into admin ball
	function dropCameraAtPlayer(%val)
	{
		clientCmdDRScopes_unRenderDRScope();
		Parent::dropCameraAtPlayer(%val);
	}
};
ActivatePackage(DualRenderPackage);


// Testing util
function rebuildScope()
{
	exec("./client.cs");
}